# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from led_msgs/LEDStateArray.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import led_msgs.msg

class LEDStateArray(genpy.Message):
  _md5sum = "c05c69b609770827fe456a05c8523fa4"
  _type = "led_msgs/LEDStateArray"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Full state of a LED strip or other set of LEDs

LEDState[] leds

================================================================================
MSG: led_msgs/LEDState
# This message represents a state of an LED

uint32 index # number of LED in a LED strip or other LEDs set
uint8 r      # red component of the color, 0..255
uint8 g      # green component of the color, 0..255
uint8 b      # blue component of the color, 0..255
"""
  __slots__ = ['leds']
  _slot_types = ['led_msgs/LEDState[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       leds

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(LEDStateArray, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.leds is None:
        self.leds = []
    else:
      self.leds = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.leds)
      buff.write(_struct_I.pack(length))
      for val1 in self.leds:
        _x = val1
        buff.write(_get_struct_I3B().pack(_x.index, _x.r, _x.g, _x.b))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.leds is None:
        self.leds = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.leds = []
      for i in range(0, length):
        val1 = led_msgs.msg.LEDState()
        _x = val1
        start = end
        end += 7
        (_x.index, _x.r, _x.g, _x.b,) = _get_struct_I3B().unpack(str[start:end])
        self.leds.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.leds)
      buff.write(_struct_I.pack(length))
      for val1 in self.leds:
        _x = val1
        buff.write(_get_struct_I3B().pack(_x.index, _x.r, _x.g, _x.b))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.leds is None:
        self.leds = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.leds = []
      for i in range(0, length):
        val1 = led_msgs.msg.LEDState()
        _x = val1
        start = end
        end += 7
        (_x.index, _x.r, _x.g, _x.b,) = _get_struct_I3B().unpack(str[start:end])
        self.leds.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_I3B = None
def _get_struct_I3B():
    global _struct_I3B
    if _struct_I3B is None:
        _struct_I3B = struct.Struct("<I3B")
    return _struct_I3B
